diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/utils/tests/test-ns3.py ns-3.40/utils/tests/test-ns3.py
--- ns-3.39/utils/tests/test-ns3.py	2023-07-05 14:23:48.141428500 -0700
+++ ns-3.40/utils/tests/test-ns3.py	2023-09-27 13:30:37.934840000 -0700
@@ -1,6 +1,6 @@
 #! /usr/bin/env python3
 #
-# Copyright (c) 2021 Universidade de Brasília
+# Copyright (c) 2021-2023 Universidade de Brasília
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License version 2 as
@@ -126,7 +126,7 @@
     @return list of programs.
     """
     values = {}
-    with open(ns3_lock_filename) as f:
+    with open(ns3_lock_filename, encoding="utf-8") as f:
         exec(f.read(), globals(), values)
 
     programs_list = values["ns3_runnable_programs"]
@@ -163,7 +163,7 @@
     @return value of the requested entry.
     """
     values = {}
-    with open(ns3_lock_filename) as f:
+    with open(ns3_lock_filename, encoding="utf-8") as f:
         exec(f.read(), globals(), values)
     return values.get(entry, None)
 
@@ -206,7 +206,7 @@
             currentTestCase.skipTest("python-on-whales was not found")
 
         # Import rootless docker settings from .bashrc
-        with open(os.path.expanduser("~/.bashrc"), "r") as f:
+        with open(os.path.expanduser("~/.bashrc"), "r", encoding="utf-8") as f:
             docker_settings = re.findall("(DOCKER_.*=.*)", f.read())
             for setting in docker_settings:
                 key, value = setting.split("=")
@@ -285,7 +285,7 @@
                 continue
 
             # Open the examples CMakeLists.txt and read it
-            with open(os.path.join(example_directory, "CMakeLists.txt"), "r") as f:
+            with open(os.path.join(example_directory, "CMakeLists.txt"), "r", encoding="utf-8") as f:
                 cmake_contents = f.read()
 
             # For each file, check if it is in the CMake contents
@@ -319,7 +319,7 @@
                 cmake_path = os.path.join(parent_directory, os.path.basename(cmake_path))
 
             # Open the module CMakeLists.txt and read it
-            with open(cmake_path, "r") as f:
+            with open(cmake_path, "r", encoding="utf-8") as f:
                 cmake_contents = f.read()
 
             # For each file, check if it is in the CMake contents
@@ -358,7 +358,7 @@
                 cmake_path = os.path.join(parent_directory, os.path.basename(cmake_path))
 
             # Open the module CMakeLists.txt and read it
-            with open(cmake_path, "r") as f:
+            with open(cmake_path, "r", encoding="utf-8") as f:
                 cmake_contents = f.read()
 
             # For each file, check if it is in the CMake contents
@@ -389,7 +389,7 @@
         for path in module_paths:
             # Open the module CMakeLists.txt and read it
             cmake_path = os.path.join(path, "CMakeLists.txt")
-            with open(cmake_path, "r") as f:
+            with open(cmake_path, "r", encoding="utf-8") as f:
                 cmake_contents = f.readlines()
 
             module_name = os.path.relpath(path, ns3_path)
@@ -957,7 +957,7 @@
             ns3rc_template = ns3rc_str(ns3rc_type)
 
             # Now we repeat the command line tests but with the ns3rc file.
-            with open(ns3rc_script, "w") as f:
+            with open(ns3rc_script, "w", encoding="utf-8") as f:
                 f.write(ns3rc_template.format(modules="'lte'", examples="False", tests="True"))
 
             # Reconfigure.
@@ -972,7 +972,7 @@
             self.assertLessEqual(len(get_programs_list()), len(self.ns3_executables))
 
             # Replace the ns3rc file with the wifi module, enabling examples and disabling tests
-            with open(ns3rc_script, "w") as f:
+            with open(ns3rc_script, "w", encoding="utf-8") as f:
                 f.write(ns3rc_template.format(modules="'wifi'", examples="True", tests="False"))
 
             # Reconfigure
@@ -987,7 +987,7 @@
             self.assertGreater(len(get_programs_list()), len(self.ns3_executables))
 
             # Replace the ns3rc file with multiple modules
-            with open(ns3rc_script, "w") as f:
+            with open(ns3rc_script, "w", encoding="utf-8") as f:
                 f.write(ns3rc_template.format(modules="'core','network'", examples="True", tests="False"))
 
             # Reconfigure
@@ -1004,7 +1004,7 @@
 
             # Replace the ns3rc file with multiple modules,
             # in various different ways and with comments
-            with open(ns3rc_script, "w") as f:
+            with open(ns3rc_script, "w", encoding="utf-8") as f:
                 if ns3rc_type == "python":
                     f.write(ns3rc_template.format(modules="""'core', #comment
                     'lte',
@@ -1126,7 +1126,7 @@
 
         # Cause a sigsegv
         sigsegv_example = os.path.join(ns3_path, "scratch", "sigsegv.cc")
-        with open(sigsegv_example, "w") as f:
+        with open(sigsegv_example, "w", encoding="utf-8") as f:
             f.write("""
                     int main (int argc, char *argv[])
                     {
@@ -1144,7 +1144,7 @@
 
         # Cause an abort
         abort_example = os.path.join(ns3_path, "scratch", "abort.cc")
-        with open(abort_example, "w") as f:
+        with open(abort_example, "w", encoding="utf-8") as f:
             f.write("""
                     #include "ns3/core-module.h"
 
@@ -1217,7 +1217,7 @@
         for path in test_files + backup_files:
             filepath = os.path.join(ns3_path, path)
             os.makedirs(os.path.dirname(filepath), exist_ok=True)
-            with open(filepath, "w") as f:
+            with open(filepath, "w", encoding="utf-8") as f:
                 if "main" in path:
                     f.write("int main (int argc, char *argv[]){}")
                 else:
@@ -1358,10 +1358,10 @@
         os.makedirs("contrib/borked/examples", exist_ok=True)
 
         # Test if configuration succeeds and building the module library fails
-        with open("contrib/borked/examples/CMakeLists.txt", "w") as f:
+        with open("contrib/borked/examples/CMakeLists.txt", "w", encoding="utf-8") as f:
             f.write("")
         for invalid_or_nonexistent_library in ["", "gsd", "lib", "libfi", "calibre"]:
-            with open("contrib/borked/CMakeLists.txt", "w") as f:
+            with open("contrib/borked/CMakeLists.txt", "w", encoding="utf-8") as f:
                 f.write("""
                         build_lib(
                             LIBNAME borked
@@ -1400,7 +1400,7 @@
         # - no additional library (should work)
         # - invalid library names (should fail to configure)
         # - valid library names but nonexistent libraries (should not create a target)
-        with open("contrib/borked/CMakeLists.txt", "w") as f:
+        with open("contrib/borked/CMakeLists.txt", "w", encoding="utf-8") as f:
             f.write("""
                     build_lib(
                         LIBNAME borked
@@ -1409,7 +1409,7 @@
                     )
                     """)
         for invalid_or_nonexistent_library in ["", "gsd", "lib", "libfi", "calibre"]:
-            with open("contrib/borked/examples/CMakeLists.txt", "w") as f:
+            with open("contrib/borked/examples/CMakeLists.txt", "w", encoding="utf-8") as f:
                 f.write("""
                         build_lib_example(
                             NAME borked-example
@@ -1452,9 +1452,9 @@
         os.makedirs("contrib/calibre/examples", exist_ok=True)
 
         # Now test if we can have a library with "lib" in it
-        with open("contrib/calibre/examples/CMakeLists.txt", "w") as f:
+        with open("contrib/calibre/examples/CMakeLists.txt", "w", encoding="utf-8") as f:
             f.write("")
-        with open("contrib/calibre/CMakeLists.txt", "w") as f:
+        with open("contrib/calibre/CMakeLists.txt", "w", encoding="utf-8") as f:
             f.write("""
                 build_lib(
                     LIBNAME calibre
@@ -1539,7 +1539,7 @@
                                       "VERSION_TAG_DISTANCE = '0'\n"
                                       "VERSION_BUILD_PROFILE = 'debug'\n"
                                       )
-            with open(version_cache_file, "w") as version:
+            with open(version_cache_file, "w", encoding="utf-8") as version:
                 version.write(version_cache_contents)
 
             # Configuration should now succeed
@@ -1549,7 +1549,7 @@
             self.assertTrue(os.path.exists(os.path.join(ns3_path, "cmake-cache", "build.ninja")))
 
             # And contents of version cache should be unchanged
-            with open(version_cache_file, "r") as version:
+            with open(version_cache_file, "r", encoding="utf-8") as version:
                 self.assertEqual(version.read(), version_cache_contents)
 
             # Third case: we rename the .git directory temporarily and reconfigure
@@ -1571,7 +1571,7 @@
             container.execute("./ns3 configure -G Ninja --enable-build-version")
             container.execute("./ns3 build core")
             self.assertTrue(os.path.exists(os.path.join(ns3_path, "cmake-cache", "build.ninja")))
-            with open(version_cache_file, "r") as version:
+            with open(version_cache_file, "r", encoding="utf-8") as version:
                 self.assertNotEqual(version.read(), version_cache_contents)
 
             # Remove version cache file if it exists
@@ -1638,7 +1638,7 @@
 
             # Check if configuration properly detected lld
             self.assertTrue(os.path.exists(os.path.join(ns3_path, "cmake-cache", "build.ninja")))
-            with open(os.path.join(ns3_path, "cmake-cache", "build.ninja"), "r") as f:
+            with open(os.path.join(ns3_path, "cmake-cache", "build.ninja"), "r", encoding="utf-8") as f:
                 self.assertIn("-fuse-ld=lld", f.read())
 
             # Try to build using the lld linker
@@ -1659,7 +1659,7 @@
 
             # Check if configuration properly detected mold
             self.assertTrue(os.path.exists(os.path.join(ns3_path, "cmake-cache", "build.ninja")))
-            with open(os.path.join(ns3_path, "cmake-cache", "build.ninja"), "r") as f:
+            with open(os.path.join(ns3_path, "cmake-cache", "build.ninja"), "r", encoding="utf-8") as f:
                 self.assertIn("-fuse-ld=mold", f.read())
 
             # Try to build using the lld linker
@@ -1676,7 +1676,7 @@
 
             # Check if configuration properly disabled lld/mold usage
             self.assertTrue(os.path.exists(os.path.join(ns3_path, "cmake-cache", "build.ninja")))
-            with open(os.path.join(ns3_path, "cmake-cache", "build.ninja"), "r") as f:
+            with open(os.path.join(ns3_path, "cmake-cache", "build.ninja"), "r", encoding="utf-8") as f:
                 self.assertNotIn("-fuse-ld=mold", f.read())
 
     def test_21_ClangTimeTrace(self):
@@ -1958,7 +1958,7 @@
         self.ns3_libraries = get_libraries_list()
 
         version_file = os.sep.join([ns3_path, "VERSION"])
-        with open(version_file, "w") as f:
+        with open(version_file, "w", encoding="utf-8") as f:
             f.write("3-00\n")
 
         # Reconfigure.
@@ -1990,7 +1990,7 @@
             self.assertTrue(os.path.exists(library))
 
         # Restore version file.
-        with open(version_file, "w") as f:
+        with open(version_file, "w", encoding="utf-8") as f:
             f.write("3-dev\n")
 
     def test_07_OutputDirectory(self):
@@ -2077,7 +2077,7 @@
 
         # 3-dev version format is not supported by CMake, so we use 3.01.
         version_file = os.sep.join([ns3_path, "VERSION"])
-        with open(version_file, "w") as f:
+        with open(version_file, "w", encoding="utf-8") as f:
             f.write("3-01\n")
 
         # Reconfigure setting the installation folder to ns-3-dev/build/install.
@@ -2113,7 +2113,7 @@
 
         # Now create a test CMake project and try to find_package ns-3.
         test_main_file = os.sep.join([install_prefix, "main.cpp"])
-        with open(test_main_file, "w") as f:
+        with open(test_main_file, "w", encoding="utf-8") as f:
             f.write("""
             #include <ns3/core-module.h>
             using namespace ns3;
@@ -2163,7 +2163,7 @@
                                      """ + import_method
 
                 test_cmake_project_file = os.sep.join([install_prefix, "CMakeLists.txt"])
-                with open(test_cmake_project_file, "w") as f:
+                with open(test_cmake_project_file, "w", encoding="utf-8") as f:
                     f.write(test_cmake_project)
 
                 # Configure the test project
@@ -2215,7 +2215,7 @@
 
         # Restore 3-dev version file
         os.remove(version_file)
-        with open(version_file, "w") as f:
+        with open(version_file, "w", encoding="utf-8") as f:
             f.write("3-dev\n")
 
     def test_09_Scratches(self):
@@ -2834,6 +2834,98 @@
         self.assertIn("scratch-simulator", stdout)
         self.assertIn("(lldb) target create", stdout)
 
+    def test_18_CpmAndVcpkgManagers(self):
+        """!
+        Test if CPM and Vcpkg package managers are working properly
+        @return None
+        """
+        # Clean the ns-3 configuration
+        return_code, stdout, stderr = run_ns3("clean")
+        self.assertEqual(return_code, 0)
+
+        # Cleanup VcPkg leftovers
+        if os.path.exists("vcpkg"):
+            shutil.rmtree("vcpkg")
+
+        # Copy a test module that consumes armadillo
+        destination_src = os.path.join(ns3_path, "src/test-package-managers")
+        # Remove pre-existing directories
+        if os.path.exists(destination_src):
+            shutil.rmtree(destination_src)
+
+        # Always use a fresh copy
+        shutil.copytree(os.path.join(ns3_path, "build-support/test-files/test-package-managers"),
+                        destination_src)
+
+        with DockerContainerManager(self, "ubuntu:22.04") as container:
+            # Install toolchain
+            container.execute("apt-get update")
+            container.execute("apt-get install -y python3 cmake g++ ninja-build")
+
+            # Verify that Armadillo is not available and that we did not
+            # add any new unnecessary dependency when features are not used
+            try:
+                container.execute(
+                    "./ns3 configure -- -DTEST_PACKAGE_MANAGER:STRING=ON")
+                self.skipTest("Armadillo is already installed")
+            except DockerException as e:
+                pass
+
+            # Clean cache to prevent dumb errors
+            return_code, stdout, stderr = run_ns3("clean")
+            self.assertEqual(return_code, 0)
+
+            # Install CPM and VcPkg shared dependency
+            container.execute("apt-get install -y git")
+
+            # Install Armadillo with CPM
+            try:
+                container.execute(
+                    "./ns3 configure -- -DNS3_CPM=ON -DTEST_PACKAGE_MANAGER:STRING=CPM")
+            except DockerException as e:
+                self.fail()
+
+            # Try to build module using CPM's Armadillo
+            try:
+                container.execute(
+                    "./ns3 build test-package-managers")
+            except DockerException as e:
+                self.fail()
+
+            # Clean cache to prevent dumb errors
+            return_code, stdout, stderr = run_ns3("clean")
+            self.assertEqual(return_code, 0)
+
+            # Install VcPkg dependencies
+            container.execute("apt-get install -y zip unzip tar curl")
+
+            # Install Armadillo dependencies
+            container.execute("apt-get install -y pkg-config gfortran")
+
+            # Install VcPkg
+            try:
+                container.execute(
+                    "./ns3 configure -- -DNS3_VCPKG=ON")
+            except DockerException as e:
+                self.fail()
+
+            # Install Armadillo with VcPkg
+            try:
+                container.execute("./ns3 configure -- -DTEST_PACKAGE_MANAGER:STRING=VCPKG")
+            except DockerException as e:
+                self.fail()
+
+            # Try to build module using VcPkg's Armadillo
+            try:
+                container.execute(
+                    "./ns3 build test-package-managers")
+            except DockerException as e:
+                self.fail()
+
+        # Remove test module
+        if os.path.exists(destination_src):
+            shutil.rmtree(destination_src)
+
 
 class NS3QualityControlTestCase(unittest.TestCase):
     """!
@@ -2907,7 +2999,7 @@
                         continue
 
                     try:
-                        with open(filepath, "r") as f:
+                        with open(filepath, "r", encoding="utf-8") as f:
                             matches = regex.findall(f.read())
 
                             # Get first group for each match (containing the URL)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/utils/tests/test-test.py ns-3.40/utils/tests/test-test.py
--- ns-3.39/utils/tests/test-test.py	2023-07-05 14:23:48.141428500 -0700
+++ ns-3.40/utils/tests/test-test.py	2023-09-27 13:30:37.934840000 -0700
@@ -19,7 +19,7 @@
 # NOTE: Run this script with the Python3 interpreter if the python3 compatibility
 #       of the ns-3 unit test runner needs to be tested.
 
-#   The following options of test.py are being tested for poratability by this script.
+#   The following options of test.py are being tested for portability by this script.
 #   To see the options supported by this script, run with the -h option on the command line
 #
 #   -h, --help            show this help message and exit
@@ -71,49 +71,50 @@
         Prepares test cases and executes
     """
     test_cases = [
-      '',
-      '-h',
-      '--help',
-      '-b build/',
-      '--buildpath=build/',
-      '-c performance',
-      '--constrain=performance',
-      '-d',
-      '--duration',
-      '-e socket-options-ipv6',
-      '--example=socket-options-ipv6',
-      '-u',
-      '--update-data',
-      '-f EXTENSIVE --fullness=EXTENSIVE'
-      '-g',
-      '--grind',
-      '-l',
-      '--list',
-      '-m',
-      '--multiple',
-      '-n',
-      '--no-build',
-      '-p first',
-      '--pyexample=first',
-      '-r',
-      '--retain',
-      '-s ns3-tcp-interoperability',
-      '--suite=ns3-tcp-interoperability',
-      '-t t_opt.txt',
-      '--text=t_opt.txt && rm -rf t_opt.txt',
-      '-v',
-      '--verbose',
-      '-w t_opt.html && rm -rf t_opt.html',
-      '--web=t_opt.html && rm -rf t_opt.html',
-      '--html=t_opt.html && rm -rf t_opt.html',
-      '-x t_opt.xml && rm -rf t_opt.xml',
-      '--xml=t_opt.xml && rm -rf t_opt.xml',
+        '',
+        '-h',
+        '--help',
+        '-b build/',
+        '--buildpath=build/',
+        '-c performance',
+        '--constrain=performance',
+        '-d',
+        '--duration',
+        '-e socket-options-ipv6',
+        '--example=socket-options-ipv6',
+        '-u',
+        '--update-data',
+        '-f EXTENSIVE',
+        '--fullness=EXTENSIVE',
+        '-g',
+        '--grind',
+        '-l',
+        '--list',
+        '-m',
+        '--multiple',
+        '-n',
+        '--no-build',
+        '-p first',
+        '--pyexample=first',
+        '-r',
+        '--retain',
+        '-s ns3-tcp-state',
+        '--suite=ns3-tcp-state',
+        '-t t_opt.txt',
+        '--text=t_opt.txt && rm t_opt.txt',
+        '-v',
+        '--verbose',
+        '-w t_opt.html && rm t_opt.html',
+        '--web=t_opt.html && rm t_opt.html',
+        '--html=t_opt.html && rm t_opt.html',
+        '-x t_opt.xml && rm t_opt.xml',
+        '--xml=t_opt.xml && rm t_opt.xml',
     ]
 
     configure_string = sys.executable + ' ns3 configure --enable-tests --enable-examples'
     clean_string = sys.executable + ' ns3 clean'
-    cmd_execute_list = [ '%s && %s test.py %s && %s' % (configure_string, sys.executable, option, clean_string) for option in test_cases]
-    runner = TestBaseClass(argv[1:], "Test suite for the ns-3 unit test runner" , 'test-py')
+    cmd_execute_list = ['%s && %s test.py %s && %s' % (configure_string, sys.executable, option, clean_string) for option in test_cases]
+    runner = TestBaseClass(argv[1:], "Test suite for the ns-3 unit test runner", 'test-py')
     return runner.runtests(cmd_execute_list)
 
 if __name__ == '__main__':
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/utils.py ns-3.40/utils.py
--- ns-3.39/utils.py	2023-07-05 14:23:48.137428500 -0700
+++ ns-3.40/utils.py	2023-09-27 13:30:37.934840000 -0700
@@ -5,7 +5,7 @@
 # should be enabled
 
 import os
-import sys
+
 
 def get_list_from_file(file_path, list_name):
     '''Looks for a Python list called list_name in the file specified
@@ -20,7 +20,7 @@
 
     # Read in the file if it exists.
     if os.path.exists(file_path):
-        with open(file_path, "r") as file_in:
+        with open(file_path, "r", encoding="utf-8") as file_in:
 
             # Look for the list.
             list_string = ""
@@ -58,7 +58,7 @@
 
     # Read in the file if it exists.
     if os.path.exists(file_path):
-        with open(file_path, "r") as file_in:
+        with open(file_path, "r", encoding="utf-8") as file_in:
 
             # Look for the boolean variable.
             bool_found = False
@@ -121,4 +121,3 @@
     tests_enabled = get_bool_from_file(dot_ns3rc_path, 'tests_enabled', value_if_missing)
 
     return (config_file_exists, modules_enabled, examples_enabled, tests_enabled)
-
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/VERSION ns-3.40/VERSION
--- ns-3.39/VERSION	2023-07-05 14:24:01.481474000 -0700
+++ ns-3.40/VERSION	2023-09-27 13:30:55.802883400 -0700
@@ -1 +1 @@
-3.39
+3.40
